function varargout = demo_sine(varargin)
% DEMO_SINE M-file for demo_sine.fig
%      DEMO_SINE, by itself, creates a new DEMO_SINE or raises the existing
%      singleton*.
%
%      H = DEMO_SINE returns the handle to a new DEMO_SINE or the handle to
%      the existing singleton*.
%
%      DEMO_SINE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEMO_SINE.M with the given input arguments.
%
%      DEMO_SINE('Property','Value',...) creates a new DEMO_SINE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before demo_sine_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to demo_sine_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2005 Colin Macdonald, released under GPL

% Edit the above text to modify the response to help demo_sine

% Last Modified by GUIDE v2.5 17-Feb-2005 14:11:01

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @demo_sine_OpeningFcn, ...
                   'gui_OutputFcn',  @demo_sine_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demo_sine is made visible.
function demo_sine_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to demo_sine (see VARARGIN)

% Choose default command line output for demo_sine
handles.output = hObject;

handles.numpoints = 200;
handles.currentProb = 1;
probs(1).k = [1 2 3];
probs(2).k = [1 2 3];
probs(3).k = [1 2 3];
probs(4).k = [1 5 8];
probs(5).k = [1 3 7];
probs(1).at = [2 0 0];
probs(2).at = [2 0 1];
probs(3).at = [10 2 3];
probs(4).at = [1 2 10];
probs(5).at = [12 4 1];
% this will get assigned later randomly
probs(6).at = [0 0 0];
probs(6).k = [0 0 0];
handles.lastProb = 6;
handles.probs = probs;

problist = {'Simple 1' 'A' 'B' 'C' 'D' 'Random'};
set(handles.probpopup, 'String', problist);
set(handles.probpopup, 'Value', 1);

set(handles.mode1, 'String', 0);
set(handles.mode2, 'String', 0);
set(handles.mode3, 'String', 0);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes demo_sine wait for user response (see UIRESUME)
% uiwait(handles.figure1);

updateSmallAxes(handles)
updateMainAxes(handles)



function updateSmallAxes(handles)
  % update the smaller plots and the labels

  k = handles.probs(handles.currentProb).k;
  xx = 0:(1/handles.numpoints):1;
  axes(handles.mode1axis);
  plot(xx,sin(k(1)*2*pi*xx),'b-');
  axes(handles.mode2axis);
  plot(xx,sin(k(2)*2*pi*xx),'b-');
  axes(handles.mode3axis);
  plot(xx,sin(k(3)*2*pi*xx),'b-');
  set(handles.labelmode1, 'String', ['k1=' num2str(k(1)) ', a1=']);
  set(handles.labelmode2, 'String', ['k2=' num2str(k(2)) ', a2=']);
  set(handles.labelmode3, 'String', ['k3=' num2str(k(3)) ', a3=']);
  
  set(handles.labelHint, 'String', '');


function updateMainAxes(handles)
  %
  a(1) = str2double(get(handles.mode1, 'String'));
  a(2) = str2double(get(handles.mode2, 'String'));
  a(3) = str2double(get(handles.mode3, 'String')); 
  k = handles.probs(handles.currentProb).k;
  at = handles.probs(handles.currentProb).at;
 
  xx = 0:(1/handles.numpoints):1;
  
  axes(handles.mainaxis);
  hold off;
  H = plot(xx, at(1)*sin(k(1)*2*pi*xx) + at(2)*sin(k(2)*2*pi*xx) ...
      + at(3)*sin(k(3)*2*pi*xx), 'k-');
  set(H, 'color', [.8 .8 .8], 'linewidth', 2);
  hold on;
  plot(xx, a(1)*sin(k(1)*2*pi*xx) + a(2)*sin(k(2)*2*pi*xx) ...
      + a(3)*sin(k(3)*2*pi*xx), 'r-');
  legend('target', 'current');

  set(handles.labelHint, 'String', '');
  if all(a == at)
    set(handles.labelResult, 'String', 'Congrats!');
  else 
    set(handles.labelResult, 'String', '');  
  end



function probpopup_Callback(hObject, eventdata, handles)
  contents = get(hObject,'String');
  n = get(hObject, 'Value');
  disp(['switching to problem ' contents{n}]);
  handles.currentProb = n;
  lastProb = handles.lastProb;
  if (n == lastProb)
    disp('making new random problem');
    at = round(rand(1,3)*10);
    k1 = round(rand*10)+1;
    k2 = k1;
    k3 = k1;
    while(k2 == k1)
        k2 = round(rand*10)+1;
    end
    while((k3 == k1) | (k3 == k1))
        k3 = round(rand*10)+1;
    end
    k = sort([k1 k2 k3]);
    handles.probs(lastProb).at = at;
    handles.probs(lastProb).k = k;
  end 
 
  % Update handles structure
  guidata(hObject, handles);

  updateSmallAxes(handles);
  updateMainAxes(handles); 



function buttonHint_Callback(hObject, eventdata, handles)
  disp('Showing a random hint');
  at = handles.probs(handles.currentProb).at;
  j = round(rand*2)+1;
  set(handles.labelHint, 'String', ['a' num2str(j) ' = ' num2str(at(j))]);



function buttonRedraw_Callback(hObject, eventdata, handles)
  updateMainAxes(handles);


  
% uncomment to update plots when textboxes change
function mode1_Callback(hObject, eventdata, handles)
  %updateMainAxes(handles);
function mode2_Callback(hObject, eventdata, handles)
  %updateMainAxes(handles);
function mode3_Callback(hObject, eventdata, handles)
  %updateMainAxes(handles);

  
% --- Outputs from this function are returned to the command line.
function varargout = demo_sine_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

  
function mode1axis_CreateFcn(hObject, eventdata, handles)
function mode2axis_CreateFcn(hObject, eventdata, handles)
function mode3axis_CreateFcn(hObject, eventdata, handles)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over buttonRedraw.
function buttonRedraw_ButtonDownFcn(hObject, eventdata, handles)


function probpopup_CreateFcn(hObject, eventdata, handles)
% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function mode1_CreateFcn(hObject, eventdata, handles)
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function mode2_CreateFcn(hObject, eventdata, handles)
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function mode3_CreateFcn(hObject, eventdata, handles)
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end