% load_image
%   converts jpeg or gif image file to 
%   matlab array of monocolor [0,1] data
%
% cbm, 2005-02-18 based on code by djm

disp('**************************************************************');
disp ('Now choose an image:');
ls *.jpg
ls *.png
file = input('enter a filename (including extension): ', 's');
%file = 'circles.jpg';
%file = 'lines.jpg';
%file = 'moire.jpg';
%file = 'sfu.jpg';
%file = 'triangle.jpeg';
%file = 'skylab.jpg';
%file = 'Line.png';
%file = 'sticks.jpg';

%  read imagefile & convert to matlab array
imdata = imread(file);  imsize  = size(imdata);

switch ndims(imdata)
    case{2} % monocolor image
        imdata  = double(imdata)/255;
    case{3} % RGB 3-color image - convert to monocolor 
        rgb     = reshape(imdata(:),imsize(1)*imsize(2),3);
        
            %  RGB-to-monocolor conversion constants
        T       = inv([1.0 0.956 0.621; 1.0 -0.272 -0.647; 1.0 -1.106 1.703]);

        imdata  = reshape(double(rgb)*T(1,:)'/255,imsize(1),imsize(2));
    otherwise
        disp('something odd about your file, try another');  return
end

imdata = imdata/max(imdata(:));
imdata = min(max(imdata,0),1);  % restrict values to [0,1]

%  optional cropping (must be even for "w2fft")
%  NOTE: reverse order of array indices!  imdata(down,across)

%  this sample line works really well with triangle.jpeg
% imdata = imdata([1:192]+8,[1:192]);  
imsize = size(imdata);
